diff --git a/doc/muxers.texi b/doc/muxers.texi
index d304181671..750ab88a18 100644
--- a/doc/muxers.texi
+++ b/doc/muxers.texi
@@ -1409,19 +1409,43 @@ how to cut the file into fragments:
 @item -moov_size @var{bytes}
 Reserves space for the moov atom at the beginning of the file instead of placing the
 moov atom at the end. If the space reserved is insufficient, muxing will fail.
-@item -movflags frag_keyframe
-Start a new fragment at each video keyframe.
 @item -frag_duration @var{duration}
 Create fragments that are @var{duration} microseconds long.
+@item -min_frag_duration @var{duration}
+Don't create fragments that are shorter than @var{duration} microseconds long.
 @item -frag_size @var{size}
 Create fragments that contain up to @var{size} bytes of payload data.
-@item -movflags frag_custom
+@item -frag_interleave @var{integer}
+Interleave samples within fragments. Max number of consecutive samples, lower is
+tighter interleaving, but with more overhead. From 0 to INT_MAX.
+@item -movflags
+MOV muxer flags. Default is 0.
+
+Possible values:
+@table @samp
+@item delay_moov
+Delay writing the initial moov until the first fragment is cut, or
+until the first fragment is flushed.
+@item frag_custom
 Allow the caller to manually choose when to cut fragments, by
 calling @code{av_write_frame(ctx, NULL)} to write a fragment with
 the packets written so far. (This is only useful with other
 applications integrating libavformat, not from @command{ffmpeg}.)
-@item -min_frag_duration @var{duration}
-Don't create fragments that are shorter than @var{duration} microseconds long.
+@item frag_discont
+Signal that the next fragment is discontinuous from earlier ones.
+@item frag_every_frame
+Fragment at every frame.
+@item frag_keyframe
+Start a new fragment at each video keyframe.
+@item skip_trailer
+Skip writing the mfra/tfra/mfro trailer for fragmented files.
+@item cmaf
+Write CMAF compatible fragmented MP4.
+@item dash
+Write DASH compatible fragmented MP4.
+@item isml
+Create a live smooth streaming feed (for pushing to a publishing point).
+@end table
 @end table
 
 If more than one condition is specified, fragments are cut when
@@ -1433,7 +1457,15 @@ Additionally, the way the output file is written can be adjusted
 through a few other options:
 
 @table @option
-@item -movflags empty_moov
+
+@item -movflags
+MOV muxer flags. Default is 0.
+
+Possible values:
+@table @samp
+
+
+@item empty_moov
 Write an initial moov atom directly at the start of the file, without
 describing any samples in it. Generally, an mdat/moov pair is written
 at the start of the file, as a normal MOV/MP4 file, containing only
@@ -1442,50 +1474,65 @@ mdat atom, and the moov atom only describes the tracks but has
 a zero duration.
 
 This option is implicitly set when writing ismv (Smooth Streaming) files.
-@item -movflags separate_moof
+@item separate_moof
 Write a separate moof (movie fragment) atom for each track. Normally,
 packets for all tracks are written in a moof atom (which is slightly
 more efficient), but with this option set, the muxer writes one moof/mdat
 pair for each track, making it easier to separate tracks.
 
 This option is implicitly set when writing ismv (Smooth Streaming) files.
-@item -movflags skip_sidx
+
+@item negative_cts_offsets
+Enables utilization of version 1 of the CTTS box, in which the CTS offsets can
+be negative. This enables the initial sample to have DTS/CTS of zero, and
+reduces the need for edit lists for some cases such as video tracks with
+B-frames. Additionally, eases conformance with the DASH-IF interoperability
+guidelines.
+
+This option is implicitly set when writing ismv (Smooth Streaming) files.
+@item skip_sidx
 Skip writing of sidx atom. When bitrate overhead due to sidx atom is high,
 this option could be used for cases where sidx atom is not mandatory.
 When global_sidx flag is enabled, this option will be ignored.
-@item -movflags faststart
+@item faststart
 Run a second pass moving the index (moov atom) to the beginning of the file.
 This operation can take a while, and will not work in various situations such
 as fragmented output, thus it is not enabled by default.
-@item -movflags rtphint
+@item rtphint
 Add RTP hinting tracks to the output file.
-@item -movflags disable_chpl
+@item disable_chpl
 Disable Nero chapter markers (chpl atom).  Normally, both Nero chapters
 and a QuickTime chapter track are written to the file. With this option
 set, only the QuickTime chapter track will be written. Nero chapters can
 cause failures when the file is reprocessed with certain tagging programs, like
 mp3Tag 2.61a and iTunes 11.3, most likely other versions are affected as well.
-@item -movflags omit_tfhd_offset
+@item omit_tfhd_offset
 Do not write any absolute base_data_offset in tfhd atoms. This avoids
 tying fragments to absolute byte positions in the file/streams.
-@item -movflags default_base_moof
+@item default_base_moof
 Similarly to the omit_tfhd_offset, this flag avoids writing the
 absolute base_data_offset field in tfhd atoms, but does so by using
 the new default-base-is-moof flag instead. This flag is new from
 14496-12:2012. This may make the fragments easier to parse in certain
 circumstances (avoiding basing track fragment location calculations
 on the implicit end of the previous track fragment).
+@item global_sidx
+Write a global sidx index at the start of the file.
+@item write_colr
+Write colr atom. Experimental, may be renamed or changed, do not use from
+scripts.
+@item prefer_icc
+If writing colr atom (with @samp{write_colr}) prioritise usage of ICC profile
+if it exists in stream packet side data.
+@item write_gama
+Write deprecated gama atom.
+@item use_metadata_tags
+Use mdta atom for metadata.
+@end table
+
 @item -write_tmcd
 Specify @code{on} to force writing a timecode track, @code{off} to disable it
 and @code{auto} to write a timecode track only for mov and mp4 output (default).
-@item -movflags negative_cts_offsets
-Enables utilization of version 1 of the CTTS box, in which the CTS offsets can
-be negative. This enables the initial sample to have DTS/CTS of zero, and
-reduces the need for edit lists for some cases such as video tracks with
-B-frames. Additionally, eases conformance with the DASH-IF interoperability
-guidelines.
-
-This option is implicitly set when writing ismv (Smooth Streaming) files.
 @item -write_prft
 Write producer time reference box (PRFT) with a specified time source for the
 NTP field in the PRFT box. Set value as @samp{wallclock} to specify timesource
@@ -1496,6 +1543,33 @@ Setting value to @samp{pts} is applicable only for a live encoding use case,
 where PTS values are set as as wallclock time at the source. For example, an
 encoding use case with decklink capture source where @option{video_pts} and
 @option{audio_pts} are set to @samp{abs_wallclock}.
+@item -skip_iods @var{boolean}
+Skip writing iods atom. Default true.
+@item -iods_audio_profile @var{integer}
+iods audio profile atom. From -1 to 255. Default -1.
+@item -iods_video_profile @var{integer}
+iods video profile atom. From -1 to 255. Default -1.
+@item -ism_lookahead @var{integer}
+Number of lookahead entries for ISM files. From 0 to INT_MAX. Default 0.
+@item -video_track_timescale @var{integer}
+Set timescale of all video tracks. From 0 to INT_MAX. Default 0.
+@item -brand @var{string}
+Override major brand.
+@item -use_editlist @var{boolean}
+Use edit list. Default auto.
+@item -fragment_index @var{integer}
+Fragment number of the next fragment. From 0 to INT_MAX. Default 0.
+@item -mov_gamma @var{float}
+Gamma value for gama atom. From 0 to 10. Default 0.
+@item -encryption_scheme @var{string}
+Configures the encryption scheme. Allowed values are @code{none} or
+@code{cenc-aes-ctr}.
+@item -encryption_key @var{binary}
+The media encryption key (hex).
+@item -encryption_kid @var{binary}
+The media encryption key identifier (hex).
+@item -use_stream_ids_as_track_ids @var{boolean}
+Use stream IDs as track IDs. Default false.
 @end table
 
 @subsection Example